#include <avr/io.h>	/* für älteres gcc das XL, XH usw. nicht vordefiniert hat
+240614	Funktionsnachweis für Testmuster aus Windows-DLL; 646 Bytes
*/
.type hkw_E,@common	// 30 Byte im Bereich 20..39
hkw_E:	.byte	20,21,22,23,39,24
	.byte	24,25,26,27,23,28 
	.byte	28,29,30,31,27,32
	.byte	32,33,34,35,31,36 
	.byte	36,37,38,39,35,20

.type hkw_C,@common	// 30 Byte im Bereich 40..79
hkw_C:	.byte	49,45,65,75,55,46
	.byte	77,47,70,64,52,50 
	.byte	66,76,56,74,40,71
	.byte	62,44,61,59,43,41 
	.byte	54,78,57,60,58,68

.type hkw_S,@common	// 160 Byte: Speicherfresser, deshalb maximal dicht
hkw_S:	.quad	0x6A4C8190D7F352EB,0xE6F9075C23A1B8D4,0x5E92B684FC0A3D71,0x79854A21ECB3360F
	.quad	0x54813AE96FD7C20B,0x437EFAC159BD0286,0x459D2F8160EAB37C,0x625A3C48EF0BD971
	.quad	0x0A239817FE654CDB,0xEC46F0A3D17982B5,0xE410D9A25B68F3C7,0x6934DCB5FA28071E
	.quad	0x2BC85D1940E67F3A,0x8AB62EF970345D1C,0xA170D9283E65F4CB,0x2E803C6D9A517FB4
	.quad	0xE4195BC38D76F02A,0x34A01B768FECD592,0xE27A594B63C1FD08,0x5472A8E1BF69C0D3

.type hkw_P,@common	// 20 Byte im Bereich 0..19
hkw_P:	.byte	18,13,15,6,8,4,10,7,2,1,19,9,14,17,12,3,11,5,0,16

// Datenteil Hi-20-Bit zum Lo-20-Bit schieben (in avr-Assembler mit swap)
Shift20R:
// PE: Y = cipher_key, R1=0
// VR: w24
	ldd	r25,Y+3
	swap	r25
	ldd	r24,Y+2
	swap	r24
	andi	r24,15
	eor	r24,r25
	andi	r25,15
	eor	r24,r25
	std	Y+0,r24
	ldd	r24,Y+4
	swap	r24
	eor	r25,r24
	andi	r24,15
	eor	r25,r24
	std	Y+1,r25
	std	Y+2,r24
	std	Y+3,r1
	std	Y+4,r1
	ret

pick30bits:
// PE: Y = cpiher_key, Z = Bitnummern-Liste (Flash-Adresse)
// PA: w18:w16 = 30 Bits
// VR: W,X,Z
	clr	r19
	ldi	r25,30
0:	lpm	r24,Z+
	mov	XL,r24
	lsr	XL
	lsr	XL
	lsr	XL
	clr	XH
	add	XL,YL
	adc	XH,YH
	ld	XL,X
	andi	r24,7
1:	lsr	XL
	dec	r24
	brpl	1b
	brcc	2f
	ori	r19,0x40
2:	lsr	r19
	ror	r18
	ror	r17
	ror	r16
	dec	r25
	brne	0b
	ret

/****************************************
 * Von avr-gcc aufrufbare Funktion	*
 *   long DecodeData(byte data[10]);	*
 * Verändert data und hinterlässt	*
 * darin den 24-Bit-Returnwert		*
 * in den Indizes 0, 1 und 2		*
 ****************************************/
.global DecodeData
DecodeData:
	push	YH
	push	YL
	movw	YL,r24
	push	r17
	push	r16
	ldi	r23,16
9:	push	r23
/* ShiftTimeRight */
// PE: Y = cipher_key, r23 = Rundenzähler 16..1
// VR: r22,w24
	ldi	r22,2
	cpi	r23,16
	breq	2f
	cpi	r23,8
	breq	2f
	cpi	r23,7
	breq	2f
	cpi	r23,3
	breq	2f
	ldi	r22,1
2:
/* Rotate2020R */
// Uhrzeit-Teil (obere 5 Byte) in zwei 20-Bit-Stücken rechts rotieren
// PE: Y = cpiher_key
// VR: w24, T-Flag
 	ldd	r25,Y+9
  	lsr	r25
	ldd	r24,Y+8
	ror	r24
	std	Y+8,r24
	ldd	r24,Y+7
	bst	r24,4
	ror	r24
	bld	r25,7
	std	Y+9,r25
	ldd	r25,Y+6
	ror	r25
	std	Y+6,r25
	ldd	r25,Y+5
	bst	r25,0
	ror	r25
	std	Y+5,r25
	bld	r24,3
	std	Y+7,r24
/* Ende Rotate2020R */
	dec	r22
	brne	2b
/* Ende ShiftTimeRight */

/* ExpandR */
// 20 auf 30 Bits expandieren
// PE: Y = cpiher_key
// PA: w18:w16 = 30 Bits
// VR: W,X,Z
	ldi	ZL,lo8(hkw_E)
	ldi	ZH,hi8(hkw_E)
	rcall	pick30bits
/* Ende ExpandR */

	movw	r20,r16
	movw	r22,r18

/* CompressKey */
// 40 Bits (Zeit) auf 30 Bits komprimieren
// PE: Y = cpiher_key
// PA: w18:w16 = 30 Bits
// VR: W,X,Z
	ldi	ZL,lo8(hkw_C)
	ldi	ZH,hi8(hkw_C)
	rcall	pick30bits
/* Ende CompressKey */

	eor	r16,r20
	eor	r17,r21
	eor	r18,r22
	eor	r19,r23

/* Sbox */
// 30 (5x6) Bits auf 20 (5x4) Bits komprimieren (Scrambling-Box)
// PE: w18:w16 = 30-Bit-Wort
// PA: r22:w20 = 20-Bit-Wort
//     w18:w16 = 0
// VR: r23, Z (erstaunlich: kein W24!)
// Um Flash zu sparen sind die Nibbles „gestürzt“ abgelegt,
// d.h. die Rundennummer (0..4) bestimmt den höchsten Teil der Adresse.
// Obendrein passen die Daten in 256 Byte: Es sind immerhin 160 Byte.
	clr	r22
	clr	r23
0:	mov	ZL,r16
	andi	ZL,0x3F		// entnimmt 6-Bit-Gruppe als Adresse
	lsr	ZL		// Nibble-zu-Byte-Adresse
	add	ZL,r23		// Rundennummer×32 dazu
	clr	ZH
	subi	ZL,lo8(-(hkw_S))
	sbci	ZH,hi8(-(hkw_S))
	lpm	ZL,Z
	sbrc	r16,0		// Lo- oder Hi-Nibble auswählen
	 swap	ZL
	andi	ZL,15
	sbrc	r23,5		// Lo- oder Hi-Target-Nibble auswählen
	 swap	ZL
	or	r22,ZL
	sbrs	r23,5		// Alle 2 Nibbles Bytekette schieben
	 rjmp	1f
	mov	r20,r21
	mov	r21,r22
	clr	r22
1:	ldi	ZL,6		// Nächste 6-Bit-Gruppe in Position bringen
2:	lsr	r19
	ror	r18
	ror	r17
	ror	r16
	dec	ZL
	brne	2b
	subi	r23,-(1<<5)	// Rundenzähler ×32 führen
	cpi	r23,5<<5	// nächste von 5 Runden
	brne	0b
/* Ende Sbox */

/* Pbox */
// 20 Bits in 20 Bits verwürfeln (Permutations-Box)
// PE: r22:w20 = 20-Bit-Wort
//     r18:w16 = 0
// PA: r18:w16 = 20-Bit-Wort
// VR: r19, X
	ldi	ZL,lo8(hkw_P)
	ldi	ZH,hi8(hkw_P)
	ldi	r23,20
3:	lpm	r19,Z+
	mov	XL,r19
	lsr	XL
	lsr	XL
	lsr	XL
	subi	XL,-20	// 3 Register ab R20 adressieren
	clr	XH
	ld	XL,X
	andi	r19,7
4:	lsr	XL	// Gewünschtes Bit nach C-Flag
	dec	r19
	brpl	4b
	brcc	5f
	ori	r18,1<<4
5:	lsr	r18
	ror	r17
	ror	r16
	dec	r23
	brne	3b
/* Ende Pbox */

// R18:16 mit cipher_key[2:0] verxoren
	ldd	XL,Y+0
	eor	r16,XL
	ldd	XL,Y+1
	eor	r17,XL
	ldd	XL,Y+2
	eor	r18,XL	// Bit 21..24 (High-Nibble) später ignorieren

	rcall	Shift20R
	
/* SetL */
// PE: Y = cipher_key, R18:W16 = 20-Bit-Wert xabcde
// PA: cipher_key[4:2h] erhält diesen (um 20 Bit verschobenen) Wert
	andi	r18,15		// 0a
	swap	r18		// a0
	swap	r17		//   cb
	eor	r18,r17		// xb		x = a^c
	andi	r17,0xF0	//   c0
	eor	r18,r17		// ab
	std	Y+4,r18		// AB okay
	swap	r16		//	ed
	eor	r17,r16		//   xd		x = c^e
	andi	r16,0xF0	//	e0
	eor	r17,r16		//   cd
	std	Y+3,r17		// CD okay
	ldd	r17,Y+2		//	  0f
	or	r16,r17		//	ef
	std	Y+2,r16		// EF okay
/* Ende SetL */
	pop	r23
	dec	r23
	breq	9f
	rjmp	9b
/* GetMeteoFromPlain */
9:	ldd	r24,Y+0		// cipher_key muss 2501x enthalten
	andi	r24,0xF0
	cpi	r24,0x10
	brne	4f
	ldd	r24,Y+1
	cpi	r24,0x50
	brne	4f
	ldd	r24,Y+2
	andi	r24,0x0F
	cpi	r24,0x02
	brne	4f
	ldd	XL,Y+0		// x retten
	andi	XL,15
	swap	XL		// x0
	rcall	Shift20R
	ldd	r22,Y+0
	ldd	r23,Y+1
	ldd	r24,Y+2
	or	r24,XL
	std	Y+2,r24		// x ins Ergebnis einbauen
	ldd	r25,Y+3		// lädt 0 von Shift20R
	rjmp	5f
4:				// Fehlerausgang: Falsche CRC
	ldi	r22,-1
	mov	r23,r22
	movw	r24,r22
/* Ende GetMeteoFromPlain */
5:	pop	r16
	pop	r17
	pop	YL
	pop	YH
	ret
